// dibdoc.h : interface of the CDibDoc class
// doug overmyer 7/1/93
// document class for bitmap data

#include "dibapi.h"

class CDibDoc : public CDocument
{
protected: // create from serialization only
	CDibDoc();  
	virtual ~CDibDoc();
	DECLARE_DYNCREATE(CDibDoc)

// Attributes    
protected:
	HDIB 				m_hDIB ;
	CPalette* 	m_palDIB;
	CSize 			m_sizeDoc;
	CBitmap* 		m_DDB;
	CPalette* 	m_palDDB ; 
	CRect*			m_rcThumb ;

// Interface
public:
	HDIB GetHDIB() const
		{ return m_hDIB; }
	CPalette* GetDocPalette() const
		{ return m_palDIB; }  
	CPalette* GetDDBPalette()
		{return m_palDDB;}
	CSize GetDocSize();
	CBitmap* GetDDB()
		{ return m_DDB;}
	CRect*	   GetThumb()
		{ return m_rcThumb;}

// Operations
public:
	void ReplaceHDIB(HDIB hDIB);
	void InitDIBData();
	void InitDDBData();
protected:
	virtual BOOL OnOpenDocument(const char* pszPathName);

// Generated message map functions
protected:
	//{{AFX_MSG(CDibDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
