// stsmtr.cpp : implementation file
// adds meter interface, drawing implementation to CStatusBar class

#include "stdafx.h" 
#include "afxext.h"
#include "stsmtr.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif             

#define CY_BORDER       1
#define CX_BORDER       1

/////////////////////////////////////////////////////////////////////////////
// CStsMtr

IMPLEMENT_DYNAMIC(CStsMtr, CStatusBar)

CStsMtr::CStsMtr()
{
	m_uPct = 0;
}

CStsMtr::~CStsMtr()
{
}

BEGIN_MESSAGE_MAP(CStsMtr, CStatusBar)
	//{{AFX_MSG_MAP(CStsMtr)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStsMtr message handlers

void CStsMtr::DoPaint(CDC* pDC)
{
  CRect 		 rcMeter;
  CBrush		 grnBrush; 
  UINT			 pct;
  
	if (m_uPct==0)
		CStatusBar::DoPaint(pDC); 
	else
		{                                                    
		pct=min(m_uPct,1);
  	grnBrush.CreateSolidBrush(RGB(0,255,0));
  	GetItemRect(0,&rcMeter);
  	rcMeter.top +=CY_BORDER;
  	rcMeter.bottom -=CY_BORDER; 
  	rcMeter.left +=CX_BORDER;  
  	rcMeter.right = rcMeter.left + rcMeter.Width() * m_uPct / 100;

  	pDC->FillRect(rcMeter,&grnBrush); 		
		}
} 

void  CStsMtr::SetPct(UINT pct)
{
  CRect 		 rc;
  GetItemRect(0,&rc);      // get rect of pane 0 (meter pane)

	if (pct == 0)            // restoring status operation, invalidate whole window
  	InvalidateRect(NULL,TRUE);     
  else if ( (m_uPct > 0) ) // just updating meter, backbround ok
  	InvalidateRect(rc,FALSE);  
  else if ( (m_uPct == 0) ) // starting meter , redraw the background
  	{
  	SetPaneText(0," ");
  	InvalidateRect(rc,TRUE);  
  	CPaintDC DC(this);      // force a repaint of pane to remove text
  	DoPaint(&DC);
  	}
 
  m_uPct = pct;
  UpdateWindow();
 }